require "macro"
local push = require "lib/push-master/push"
local moonshine = require "lib/moonshine-master"
local anim8 = require "lib/anim8-master/anim8"
local bitser = require "lib/bitser-master/bitser"
local sti = require "lib/sti-master/sti"
local camera = require 'lib/stalkerx-master/Camera'

function love.load(arg)

  love.graphics.setDefaultFilter('nearest','nearest',1)
  game = {w = ratio_w*u, h = ratio_h*u}
  window = {w = love.graphics.getWidth(), h = love.graphics.getHeight()}
  push:setupScreen(game.w, game.h, window.w, window.h, {fullscreen = false, resizable = true})
  map = sti("maps/map01.lua", { "box2d" })
  for k, object in pairs(map.objects) do
		if object.name == "START" then
			pos = object
			break
		end
	end

  cam = camera()
  cam.scale = scale
  local cx , cy =  map:convertPixelToTile(pos.x, pos.y)
  cube = {
    img = love.graphics.newImage("img/cube.png"),
    x = cx,
    y = cy,
    r = 0 ,
    g = 1 ,
    b = 1 ,
    a = 1
  }
  cam.x = cube.x
  cam.y = cube.y
end

function love.resize(w, h)
  return push:resize(w, h)
end

function love.keypressed(key, scancode, isrepeat)
  if key == 'end' then
    love.event.quit()
  end
  if key == 'tab' then
    push:switchFullscreen(window.w, window.h)
  end
end

function love.update(dt)
  map:update(dt)
end

function love.draw()
  push:start()
  cam:attach()
  if toogle.map then
    if toogle.lv1 then
    map:drawLayer(map.layers["Lv1"])
    end
    if toogle.player then
      love.graphics.setColor(cube.r,cube.g,cube.b,cube.a)
      love.graphics.draw(cube.img,cube.x,cube.y)
      love.graphics.setColor(1,1,1,1)
    end
    if toogle.lv2 then
    map:drawLayer(map.layers["Lv2"])
    end
    if toogle.lv3 then
    map:drawLayer(map.layers["Lv3"])
    end
  end
  cam:detach()
  if toogle.grid then
    draw_grid(1,1,1,1,u/2)
  end
  push:finish()
end

function draw_grid(r,g,b,a,u)
  for i = 0, window.w/u do
    for j = 0, window.h/u do
      love.graphics.setColor(r,g,b,a)
        love.graphics.rectangle("line", i*u, j*u, u, u)
      love.graphics.setColor(1,1,1,1)
    end
  end
end
